import { Injectable } from '@angular/core';
import { Subject } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
/**
 * Service to open the privacy policy and terms of use modals
 * The modals are controlled by the navbar component
 */
export class LegalService {
  private openModalSource = new Subject<string>();

  openModal$ = this.openModalSource.asObservable();

  openPrivacyPolicy() {
    this.openModalSource.next('privacyPolicy');
  }

  openTermsOfUse() {
    this.openModalSource.next('termsOfUse');
  }
}
