import { Injectable } from '@angular/core';

@Injectable({
  providedIn: 'root',
})
/**
 * THIS IS NOT A OBSERVABLE STORE.
 * This store automatically identifies if the env is production or development.
 * If this app is running on development mode, it will add port 80 to the base url.
 */
export class DevelopmentStore {
  private isDevelopment: boolean;

  constructor() {
    this.isDevelopment = location.port === '4200';
    console.log("Development mode enabled: " + this.isDevelopment);
  }

  getIsDevelopment(): boolean {
    return this.isDevelopment;
  }

  getBaseUrl(): string {
    if (this.isDevelopment) {
      return 'http://localhost:80/';
    } else {
      return window.location.origin + "/";
    }
  }
}
