package de.w665.sharepulse.db;

import com.rethinkdb.RethinkDB;
import com.rethinkdb.net.Connection;
import jakarta.annotation.PostConstruct;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

@Slf4j
@Component
@RequiredArgsConstructor
public class RethinkDBConnector {

    private final RethinkDBConfig config;
    @Getter
    private final RethinkDB r = RethinkDB.r;
    @Getter
    private Connection connection;

    @PostConstruct
    public void connectToDatabae() {
        connection = r.connection().hostname(config.getHost()).port(config.getPort()).connect();
        log.info("Connected to RethinkDB at " + config.getHost() + ":" + config.getPort() + " on database " + config.getDatabase());
    }
}
