package de.w665.sharepulse.db.repo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.rethinkdb.RethinkDB;
import com.rethinkdb.net.Connection;
import com.rethinkdb.net.Result;
import de.w665.sharepulse.db.RethinkDBConnector;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

@Repository
public class FileIdRepository {

    private final RethinkDB r;
    private final Connection connection;
    private final Gson gson;

    @Autowired
    public FileIdRepository(RethinkDBConnector connector) {
        this.r = connector.getR();
        this.connection = connector.getConnection();
        this.gson = new GsonBuilder().create();
    }

    public void insertFileId(String fileId) {
        r.db("sharepulse").table("id_store").insert(r.hashMap("fileId", fileId)).run(connection);
    }

    public boolean fileIdExists(String fileId) {
        Result<Object> result = r.db("sharepulse").table("id_store")
                .filter(r.hashMap("fileId", fileId))
                .run(connection);

        return result.hasNext();
    }
}
