package de.w665.sharepulse.rest;

import org.springframework.boot.web.servlet.error.ErrorController;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * This class is used to redirect the user to the home page if an endpoint is not found.
 */
@RestController
public class ErrorRestController implements ErrorController {
    @RequestMapping("/error")
    public ResponseEntity<Object> handleError() {
        String script =  "<script>" +
                    "console.log('Page not found. Redirecting to /home...');" +
                    "window.location.href = window.location.origin + '/home';" +
                "</script>" +
                "<h1>You've reached the default error page.</h1>" +
                "<p>This could be caused by several reasons:</p>" +
                "<ul>" +
                    "<li>The page you are looking for does not exist.</li>" +
                    "<li>The page you are looking for is not accessible.</li>" +
                    "<li>The page you are looking for is not available at the moment.</li>" +
                    "<li>The page you are looking for is not accessible without authentication.</li>" +
                "</ul>";
        return new ResponseEntity<>(script, HttpStatus.FOUND);
    }
}
