package de.w665.sharepulse.rest;

import de.w665.sharepulse.db.repo.FileUploadRepository;
import de.w665.sharepulse.model.FileUpload;
import de.w665.sharepulse.service.FileService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.InputStreamResource;
import org.springframework.core.io.Resource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

@RestController
public class TestRestResource extends ApiRestController {

    private final FileUploadRepository fileUploadRepository;
    private final FileService fileService;

    @Autowired
    public TestRestResource(FileUploadRepository fileUploadRepository, FileService fileService) {
        this.fileUploadRepository = fileUploadRepository;
        this.fileService = fileService;
    }

    @GetMapping("test")
    public FileUpload test(@RequestParam String id) {
        FileUpload fileUpload = fileUploadRepository.retrieveFileUploadByFileId(id).orElse(null);
        return fileUpload;
    }

    @GetMapping("test/download")
    public ResponseEntity<Resource> download(@RequestParam String id) throws IOException {

        File file = fileService.getFileById(id);


        HttpHeaders headers = new HttpHeaders();
        headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"edmbass.flac\"");
        //headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + file.getName() + "\"");
        headers.add(HttpHeaders.CACHE_CONTROL, "no-cache, no-store, must-revalidate");
        headers.add(HttpHeaders.PRAGMA, "no-cache");
        headers.add(HttpHeaders.EXPIRES, "0");

        InputStreamResource resource = new InputStreamResource(new FileInputStream(file));

        return ResponseEntity.ok()
                .headers(headers)
                .contentLength(file.length())
                .contentType(MediaType.APPLICATION_OCTET_STREAM)
                .body(resource);
    }
}
