package de.w665.sharepulse.rest.mappings;

import de.w665.sharepulse.db.repo.ExpiredFileUploadRepository;
import de.w665.sharepulse.db.repo.FileUploadRepository;
import de.w665.sharepulse.model.FileUpload;
import de.w665.sharepulse.rest.SecureApiRestController;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Slf4j
@RestController
public class UploadHistory extends SecureApiRestController {

    private final FileUploadRepository fileUploadRepository;
    private final ExpiredFileUploadRepository expiredFileUploadRepository;

    public UploadHistory(FileUploadRepository fileUploadRepository, ExpiredFileUploadRepository expiredFileUploadRepository) {
        this.fileUploadRepository = fileUploadRepository;
        this.expiredFileUploadRepository = expiredFileUploadRepository;
    }

    @GetMapping("/test")
    public ResponseEntity<Object> test(HttpServletRequest request) {
        log.debug("Received test request");
        return ResponseEntity.ok("Test successful");
    }

    @GetMapping("/upload-history")
    public ResponseEntity<Object> getUploadHistory(HttpServletRequest request, HttpServletResponse response) {
        List<FileUpload> fileUploadList = fileUploadRepository.findAll();
        log.debug("Received upload history request");
        return ResponseEntity.ok(fileUploadList);
    }

    @GetMapping("/expired-upload-history")
    public ResponseEntity<Object> getExpiredUploadHistory(HttpServletRequest request, HttpServletResponse response) {
        List<FileUpload> expiredFileUploadList = expiredFileUploadRepository.findAll();
        log.debug("Received expired upload history request");
        return ResponseEntity.ok(expiredFileUploadList);
    }
}
